<?php
/*
Plugin Name: LDV Generator
Plugin URI: http://www.maipiusenza.com/LDV/
Description: Modulo di esportazioni automatica dei dati per la creazione rapida di lettere di vettura con vari corrieri. 
Author: Maipiusenza
Version: 1.6.4
Author URI: http://www.maipiusenza.com/lab/
*/

if (!class_exists('WooCommerce_LDV_Generator')) {

    class WooCommerce_LDV_Generator {

        public static $plugin_prefix;
        public static $plugin_url;
        public static $plugin_path;
        public static $plugin_basename;
        public static $version;
        public $writepanels;
        public $settings;
        public $export;

        /**
         * Constructor
         */
        public function __construct() {
            self::$plugin_prefix = 'ldv_gen_';
            self::$plugin_basename = plugin_basename(__FILE__);
            self::$plugin_url = plugin_dir_url(self::$plugin_basename);
            self::$plugin_path = trailingslashit(dirname(__FILE__));
            self::$version = '1.6.4';

           
            add_action('init', array($this, 'load_classes'));
           
            add_action('plugins_loaded', array($this, 'my_plugin_init'));
      
            if (is_admin() && !defined('DOING_AJAX')) {
             

                add_action('wp_loaded', array($this, 'do_install'));
            }
			
			// SETTINGS aggiungo la voce di menu per LDV
			add_action( 'admin_menu', array( $this, 'create_ldvgenerator_settings_page' ) );
			add_action( 'admin_init', array( $this, 'ldv_setup_sections' ) );
			add_action( 'admin_init', array( $this, 'ldv_setup_fields' ) );
        }

        /**
         * Load the main plugin classes and functions
         */
        public function includes() {
           
            include_once(ABSPATH . 'wp-admin/includes/plugin.php');
        }

        /**
         * Instantiate classes when woocommerce is activated
         */
        public function load_classes() {
            if ($this->is_woocommerce_activated()) {
                $this->includes();
               
        
            } else {
                // display notice instead
                add_action('admin_notices', array($this, 'need_woocommerce'));
            }
        }

        /**
         * Check if woocommerce is activated
         */
        public function is_woocommerce_activated() {
            $blog_plugins = get_option('active_plugins', array());
            $site_plugins = get_site_option('active_sitewide_plugins', array());

            if (in_array('woocommerce/woocommerce.php', $blog_plugins) || isset($site_plugins['woocommerce/woocommerce.php'])) {
                return true;
            } else {
                return false;
            }
        }

        /**
         * WooCommerce not active notice.
         *
         * @return string Fallack notice.
         */
        public function need_woocommerce() {
            $error = sprintf(__('WooCommerce LDV Generator requires %sWooCommerce%s to be installed & activated!', 'ldv_gen'), '<a href="http://wordpress.org/extend/plugins/woocommerce/">', '</a>');

            $message = '<div class="error"><p>' . $error . '</p></div>';

            echo $message;
        }

        public function do_install() {
            // only install when woocommerce is active
            if (!$this->is_woocommerce_activated()) {
                return;
            }

            $version_setting = 'ldv_gen_version';
            $installed_version = get_option($version_setting);

            // installed version lower than plugin version?
            if (version_compare($installed_version, self::$version, '<')) {

                // if (!$installed_version && $this->is_woocommerce_activated()) {
                //     $this->install();
                // }

                // new version number
            }
        }


		 public function my_plugin_init() {
			 global $mpsDebug;
			 $mpsDebug="";
			if (class_exists('WC_order')) {
	
				function mps_add_swf_box() {
					global $wpdb;
					if ($_REQUEST['post'] || $_REQUEST['action']) {

	
						$post_id = $_REQUEST['post'];
						//$query = $wpdb->get_results('select post_type from wp_posts where ID = "' . $post_id . '"', OBJECT);
	
					 
						//$postx = (array) $query;
						//$shopord = $postx[0]->post_type;
						
						//if ($shopord == "shop_order") {
	
							global $woocommerce;
							$order = new WC_order($post_id);
							//$order      = wc_get_order( $post_id );
							
							$tid = $order->get_meta($key = 'tid');
							
							// se woocommerce è ad una versione inferiore all 2.7		
							if ( version_compare( WC_VERSION, '2.7', '<' ) ) {
								$fname = $order->shipping_first_name;
								$lname = $order->shipping_last_name;
								$company = $order->shipping_company;
								$address_1 = $order->shipping_address_1;
								$address_2 = $order->shipping_address_2;
								$postcode = $order->shipping_postcode;
								$city = $order->shipping_city;
								$note = $order->customer_note;
								$phone = $order->billing_phone;
								$email = $order->billing_email;
								$state = $order->shipping_state;
								$country = $order->shipping_country;
								$order_total = $order->get_total();
								$order_payment_method = $order->payment_method_title;
								$order_id = $order->get_id;
								$order_quantity = $order->get_item_count();
								$server = plugins_url();
		
								$weight = 0;
		
								$items = $order->get_items();
						  
								$total_weight = 0;
								$noweight = 0;
								foreach ($items as $item) {
									$itemsx = $item['item_meta_array'];
									foreach ($itemsx as $itemc) {
		
										if ($itemc->key == "_qty") {
											$quantity = $itemc->value;
										}
		
										if ($itemc->key == "_product_id") {
										   
											$item_metas = get_post_meta($itemc->value);
		
		
											$weight = $item_metas['_weight']['0'];
		
											if ($item_metas['_weight']['0'] == "") {
		
												$noweight++;
											}
		
		
											$item_weight = ( $weight * $quantity );
											$total_weight += $item_weight;
		
										}
									}
								}
							// uso una versione pari o successiva a 2.7
							} else {
								$fname = $order->get_shipping_first_name();
								$lname = $order->get_shipping_last_name();
								$company = $order->get_shipping_company();
								$address_1 = $order->get_shipping_address_1();
								$address_2 = $order->get_shipping_address_2();
								$postcode = $order->get_shipping_postcode();
								$city = $order->get_shipping_city();
								$note = $order->get_customer_note();
								$phone = $order->get_billing_phone();
								$email = $order->get_billing_email();
								$state = $order->get_shipping_state();
								$country = $order->get_shipping_country();
								$order_total = $order->get_total();
								$order_payment_method = $order->get_payment_method_title();
								$order_id = $order->get_id();
								$order_quantity = $order->get_item_count();
								$server = plugins_url();
		
								$weight = 0;
		
								$total_weight = 0;
								$noweight = 0;
								
								
								foreach( $order->get_items() as $item_id => $product_item ){
									$quantity = $product_item->get_quantity(); // get quantity
									$product = $product_item->get_product(); // get the WC_Product object
									//$product_weight = ($product->get_weight()>=0 ? $product->get_weight() : 0 ); // get the product weight
									
									$product_weight =  floatval($product->get_weight()); // get the product weight
									//$mpsDebug .= $quantity.'---'.$product_weight."<br>";
									// Add the line item weight to the total weight calculation
									$total_weight += floatval( $product_weight * $quantity );
									
									$product_weight <=0 ? $noweight++ : "";
								}
							}
							// fine else (versione WC)
							
							
							$order_weight = $total_weight;
							$unit_peso =  esc_attr( get_option('woocommerce_weight_unit' ) );
						  
							$noteClean = trim(preg_replace('/\s+/', ' ', $note));
							$ldvarray = array('topright', $server, 'PS_nome=' . $fname . '&PS_cognome=' . $lname . '&PS_company=' . $company . '&PS_addr1=' . $address_1 . '&PS_addr2=' . $address_2 . '&PS_CAP=' . $postcode . '&PS_city=' . $city . '&PS_altro=' . $noteClean . '&PS_tel1=' . $phone . '&PS_tel2=&PS_mail=' . $email . '&PS_provName=' . $state . '&PS_prov=' . $state . '&PS_nazione=' . $country . '&PS_peso=' . $order_weight . '&PS_prodSenzaPeso=' . $noweight . '&PS_unitPeso='.$unit_peso.'&PS_costoTot=' . $order_total . '&PS_modPagamento=' . $order_payment_method . '&PS_IdOrder=' . $order_id . '&PS_IdVend=' . $order_id . '&PS_pageName=ecomm-WooCom&null');
	
							//$LDV_PROTOCOL = get_option('LDV_PROTOCOL');
							$LDV_PROTOCOL = 'websocket';
							$LDV_POSITION = get_option('LDV_POSITION');
							
							// assegn lo stile per la posizione (default topRight)
							$ldvPosStyle = "";
							$ldvNoFloat = "";
							if ($LDV_POSITION=="none"){
								$ldvPosStyle = "width: 100%; clear: both;";
								$ldvNoFloat = ($LDV_PROTOCOL == 'flash' ? '' : 'class="ldvNoFloat"');
							} else if ($LDV_POSITION=="bottomRight") {
								$ldvPosStyle = " width:396px; margin-top:20px; margin-bottom:10px; position:fixed;right:0;bottom:10px; z-index:9990;";
							} else if ($LDV_POSITION=="bottomLeft") {
								$ldvPosStyle = " width:396px; margin-top:20px; margin-bottom:10px; position:fixed;left:0;bottom:10px; z-index:9990;";
							} else if ($LDV_POSITION=="topLeft") {
								$ldvPosStyle = " width:396px; margin-top:20px; margin-bottom:10px; position:fixed;left:0;top:25px; z-index:9990;";
							} else { // topRight
								$ldvPosStyle = " width:396px; margin-top:20px; margin-bottom:10px; position:fixed;right:0;top:25px; z-index:9990;";
							}
							
							
							$mpsFlashContent='<div id="flashContent" '.$ldvNoFloat.' style=" clear:both; '.$ldvPosStyle.'">
								<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" width="100%" height="158" id="Sender" align="middle" style="outline:none;">
								<param name="movie" value="'.plugins_url().'/ldvgenerator/Sender_LDVgenerator_1p6.swf" />
									<param name="quality" value="high" />
									<param name="play" value="true" />
									<param name="loop" value="true" />
									<param name="wmode" value="transparent" />
									<param name="scale" value="showall" />
									<param name="menu" value="true" />
									<param name="devicefont" value="false" />
									<param name="salign" value="" />
									<param name="allowScriptAccess" value="always" />
									<param name="flashvars" value="'.$ldvarray[2].'&null" /> 
									<!--[if !IE]>-->
									<object type="application/x-shockwave-flash" data="'.$ldvarray[1].'/ldvgenerator/Sender_LDVgenerator_1p6.swf" width="100%" height="158" style="outline:none;">
										<param name="movie" value="'.$ldvarray[1].'/ldvgenerator/Sender_LDVgenerator_1p6.swf" />
										<param name="quality" value="high" />
										<param name="play" value="true" />
										<param name="loop" value="true" />
										<param name="wmode" value="transparent" />
										<param name="scale" value="showall" />
										<param name="menu" value="true" />
										<param name="devicefont" value="false" />
										<param name="salign" value="" />
										<param name="allowScriptAccess" value="always" />
										<param name="flashvars" value="'.$ldvarray[2].'&null" />
										<!--<![endif]-->
										<a href="https://www.adobe.com/go/getflash">
											<img src="https://www.adobe.com/images/shared/download_buttons/get_flash_player.gif" alt="Scarica Adobe Flash Player" />
										</a>
										<!--[if !IE]>-->
									</object>
									<!--<![endif]-->
								</object>
							</div>
	';
							
							
							
							$mpsPluginDirRel = "/".substr(plugin_dir_path( __FILE__ ), strrpos(plugin_dir_path( __FILE__ ), "wp-content"));
							$mpsPluginDirRel = str_replace("\\","/",$mpsPluginDirRel);
							
							
							
/*
C:\xampp\apps\wordpress\htdocs\wp-content\plugins\ldvgenerator/			
C:\xampp\apps\wordpress\htdocs\wp-content\plugins\ldvgenerator/

/wp-content\plugins\ldvgenerator/

*/				
							
							$mpsSocketContent = '
        <div id="flashContent" '.$ldvNoFloat.' style="'.$ldvPosStyle.'">
			<div id="LDVall">
				<div id="LDVstatus"></div>
				<div style=" color:#FFF; font-weight: bold; font-size:13px; font-style:italic; text-align:left; margin:0 0 0 25px; float:left; line-height:120%; height:37px;">Scegli il corriere qui sotto e invia i dati<br />
					dell\'ordine a LDV Generator
				</div>
				<a id="LdvInvia" class="LdvInv" style="display:none;" href="javascript:void(0);" onclick="SendVars();"><span>Invia</span></a>
				<div id="LDV_fascia"></div>
				<ul id="LDVul">
					<li><a id="EBOOST" style=" background-image:url(../'.$mpsPluginDirRel.'img/tab_ebo.png);" class="LDV_spento" href="javascript:void(0);" onclick=\'setCookie("EBOOST")\'><span>eBoost</span></a></li>
					<li><a id="GLS" style="background-image:url(../'.$mpsPluginDirRel.'img/tab_gls.png);" class="LDV_spento" href="javascript:void(0);" onclick=\'setCookie("GLS")\'><span>GLS</span></a></li>
					<li><a id="SDA" style="background-image:url(../'.$mpsPluginDirRel.'img/tab_sda.png);" class="LDV_spento" href="javascript:void(0);" onclick=\'setCookie("SDA")\'><span>SDA</span></a></li>
					<li><a id="BRT" style="background-image:url(../'.$mpsPluginDirRel.'img/tab_brt.png);" class="LDV_spento" href="javascript:void(0);" onclick=\'setCookie("BRT")\'><span>BRT</span></a></li>
					<li><a id="SW" style="background-image:url(../'.$mpsPluginDirRel.'img/tab_swb.png);" class="LDV_spento" href="javascript:void(0);" onclick=\'setCookie("SW")\'><span>SpedireWeb</span></a></li>
					<li><a id="JOL" style="background-image:url(../'.$mpsPluginDirRel.'img/tab_jol.png);" class="LDV_spento" href="javascript:void(0);" onclick=\'setCookie("JOL")\'><span>Jolly</span></a></li>
				</ul>
				
				<div id="LDV_footer"><div style="float:left; padding-left:2px;">s1.8S</div>modulo Importazione Dati</div>
			</div>
			<script type="text/javascript">
				var txtNoPeso1 = "ATTENZIONE, almeno un prodotto acquistato ha un peso pari a zero.";
				var txtNoPeso2 = "Verifica il peso totale prima di generare la Lettera di vettura.";
				txtCorr = "Corriere selezionato";
				txtInvio = "Invio in corso...";
				txtSent1 =  "INVIO EFFETTUATO.";
				txtSent2 =  "Spostarsi su LDV Generator per controllare i dati e creare la LDV.";
				txtError1 = "ERRORE NELL\'INVIO DEI DATI.";
				txtError2 = "Verificare che LDV Generator sia aperto e riprovare.";
				
				var prodSenzaPeso = '.$noweight.';
				flashvars = "PS_ld='.$ldvarray[1].'__v.1.6.4&'.$ldvarray[2].'&null;";
				
				if (getCookie("LDV_corriere").length>0) {
					setCookie(getCookie("LDV_corriere"));
				}
					if (prodSenzaPeso > 0 ) {
						document.getElementById("LDVstatus").appendChild(document.createTextNode(txtNoPeso1.toUpperCase()));
						document.getElementById("LDVstatus").appendChild(document.createElement("br"));
						document.getElementById("LDVstatus").appendChild(document.createTextNode(txtNoPeso2.toUpperCase()));
				
					}
			</script>
        </div>
';
							// mostro il box in base alle necessità, default socket
							if ($LDV_PROTOCOL == "flash") {
								echo $mpsFlashContent;
							} else {
								echo $mpsDebug.$mpsSocketContent;
							}							
					}
				}
				//fine mps_add_swf_box
				add_action( 'woocommerce_admin_order_data_after_order_details', 'mps_add_swf_box', 9 );		
			
			
			
				// aggiungo js e css
				function callback_for_setting_up_scripts() {
					//$mpsPluginDirRel = "/".substr(plugin_dir_path( __FILE__ ), strrpos(plugin_dir_path( __FILE__ ), "wp-content/"));
					$mpsPluginDirRel = "/".substr(plugin_dir_path( __FILE__ ), strrpos(plugin_dir_path( __FILE__ ), "wp-content"));
					$mpsPluginDirRel = str_replace("\\","/",$mpsPluginDirRel);
				
					$myDir= plugin_dir_path( __FILE__ );
					wp_register_style ( 'ldvCSS', $mpsPluginDirRel.'css/back.css' );
					wp_register_script ( 'ldvJS', $mpsPluginDirRel.  'js/ldv.js' );
					wp_enqueue_style( 'ldvCSS' );
					wp_enqueue_script( 'ldvJS');
				}
				add_action('admin_enqueue_scripts', 'callback_for_setting_up_scripts');
				// fine CSS e JS
			


			// AGGIUNGO LA PAGINA SETTINGS			
			function plugin_add_settings_link( $links ) {
				$settings_link = '<a href="options-general.php?page=ldv_fields">' . __( 'Settings' ) . '</a>';
				
				array_unshift($links, $settings_link);
				return $links;
			}
			$plugin = plugin_basename( __FILE__ );
			add_filter( "plugin_action_links_$plugin", 'plugin_add_settings_link' );


			
			}
		}
		//fine my_plugin_init
		
	
		// https://www.smashingmagazine.com/2016/04/three-approaches-to-adding-configurable-fields-to-your-plugin/
		function create_ldvgenerator_settings_page() {
			// Add the menu item and page
			$page_title = 'Ldv Generator - Impostazioni';
			$menu_title = 'Ldv Generator';
			$capability = 'manage_options';
			$slug = 'ldv_fields';
			$callback = array( $this, 'ldvgenerator_settings_page_content' );
			//$icon = 'dashicons-admin-plugins';
			//$position = 100;
		
			//add_menu_page( $page_title, $menu_title, $capability, $slug, $callback, $icon, $position );
			// lo moeeto sotto impostazioni
			add_submenu_page( 'options-general.php', $page_title, $menu_title, $capability, $slug, $callback );
		}
				
		public function ldvgenerator_settings_page_content() {
?>
    <div class="wrap">
        <h2>Impostazioni per LDV Generator</h2>
        <form method="post" action="options.php">
        <!--<form method="post" action="options-general.php?page=ldv_fields">-->
            <?php
                settings_fields( 'ldv_fields' );
                do_settings_sections( 'ldv_fields' );
                submit_button();
            ?>
        </form>
    </div> 
<?php
			}	
			public function ldv_setup_sections() {
				//add_settings_section( 'our_first_section', 'My First Section Title', false, 'ldv_fields' );
				add_settings_section( 'our_first_section', 'Ldv Generator - Impostazioni', array( $this, 'ldv_section_callback' ), 'ldv_fields' );
				//add_settings_section( 'our_second_section', 'My Second Section Title', array( $this, 'ldv_section_callback' ), 'ldv_fields' );
				//add_settings_section( 'our_third_section', 'My Third Section Title', array( $this, 'ldv_section_callback' ), 'ldv_fields' );


			}
			public function ldv_section_callback( $arguments ) {
				$ldvSettDescr = '
				

				<p>
					</p><h3 style="font-size:14px; /*font-weight:bold;*/ ">Di seguito puoi selezionare la posizione del box nella pagina e il protocollo di trasmissione dei dati.</h3>
					<p style="font-size:13px;"><strong style="text-transform:uppercase; font-weight:bold;">Note riguardo il protocollo di trasmissione dei dati</strong><br>
					A partire dal 2021 il protocollo di trasmissione "Adobe Flash" non è più utilizzabile. Pertanto il plugin è stato modificato per trasmettere i dati tramite altro protocollo (Websocket), si prega di tener presente:</p>

					<ul class="ul-spaced">
						<li><strong>Se usi Firefox</strong> e le pagine del pannello di amministrazione del sito usano SSL (l\'url inizia per "https" invece di "http"), devi autorizzare manualmente il trasferimento dei dati al primo utilizzo, quindi digita <strong>"about:config"</strong> nella barra dell\'indirizzo di Firefox e premi invio (poi clicca su "Accetto il rischio!"), quindi digita nella barra di ricerca "fromhttps"; la lista in basso mostrerà la riga "network.websocket.allowInsecureFromHTTPS", fare doppio click sulla riga per modificare il valore da false a true e chiudere la pagina. <br>&nbsp;</li>
						<li>Se usi anche l\'add-on per Ebay e Amazon, avrai bisogno di seguire le stesse istruzioni utilizzate per questo modulo.</li>
					</ul>
				<p></p>
							
				
				';
				switch( $arguments['id'] ){
					case 'our_first_section':
						echo /*'This is the first description here!'*/$ldvSettDescr;
						break;
					/*case 'our_second_section':
						echo 'This one is number two';
						break;
					case 'our_third_section':
						echo 'Third time is the charm!';
						break;
					*/
				}
			}
			
			public function ldv_setup_fields() {
				//add_settings_field( 'our_first_field', 'Field Name', array( $this, 'ldv_field_callback' ), 'ldv_fields', 'our_first_section' );
$fields = array(
    /*array(
        'uid' => 'our_first_field',
        'label' => 'Awesome Date',
        'section' => 'our_first_section',
        'type' => 'text',
        'options' => false,
        'placeholder' => 'DD/MM/YYYY',
        'helper' => 'Does this help?',
        'supplemental' => 'I am underneath!',
        'default' => '01/01/2015'
    ),
    array(
        'uid' => 'our_second_field',
        'label' => 'Awesome Date',
        'section' => 'our_first_section',
        'type' => 'textarea',
        'options' => false,
        'placeholder' => 'DD/MM/YYYY',
        'helper' => 'Does this help?',
        'supplemental' => 'I am underneath!',
        'default' => '01/01/2015'
    ),/*
    array(
        'uid' => 'our_third_field',
        'label' => 'Awesome Select',
        'section' => 'our_first_section',
        'type' => 'select',
        'options' => array(
            'yes' => 'Yeppers',
            'no' => 'No way dude!',
            'maybe' => 'Meh, whatever.'
        ),
        'placeholder' => 'Text goes here',
        'helper' => 'Does this help?',
        'supplemental' => 'I am underneath!',
        'default' => 'maybe'
    )*/
    array(
        'uid' => 'LDV_POSITION',
        'label' => 'Posizione: ',
        'section' => 'our_first_section',
        'type' => 'radio',
        'options' => array(
            'topRight' => 'In alto a destra (Fisso)',
            'topLeft' => 'In alto a sinistra (Fisso)',
            'bottomRight' => 'In basso a destra (Fisso)',
            'bottomLeft' => 'In basso a sinistra (Fisso)',
            'none' => 'Sotto "Dettagli generali" (con alcune risuluzioni dello schermo il box potrebbe risultare molto piccolo)'
        ),
        'placeholder' => '',
        'helper' => '',
        'supplemental' => 'Selezionare dove si preferisce mostrare il box di LDV Generator',
        'default' => 'topRight'
    ),
	/*
    array(
        'uid' => 'LDV_PROTOCOL',
        'label' => 'Protocollo di trasmissione dati: ',
        'section' => 'our_first_section',
        'type' => 'radio',
        'options' => array(
            'websocket' => 'Websocket',
            'flash' => 'Adobe Flash'
        ),
        'placeholder' => '',
        'helper' => '',
        'supplemental' => 'Selezionare...',
        'default' => 'websocket'
    )
	*/
);





				foreach( $fields as $field ){
					add_settings_field( $field['uid'], $field['label'], array( $this, 'ldv_field_callback' ), 'ldv_fields', $field['section'], $field );
					register_setting( 'ldv_fields', $field['uid'] );
				}



			}			
			public function ldv_field_callback( $arguments ) {
				/*
				echo '<input name="our_first_field" id="our_first_field" type="text" value="' . get_option( 'our_first_field' ) . '" />';
				add_option("our_first_field", "", "", "yes");
				register_setting( 'ldv_fields', 'our_first_field' );
				*/
				
    $value = get_option( $arguments['uid'] ); // Get the current value, if there is one
    if( ! $value ) { // If no value exists
        $value = $arguments['default']; // Set to our default
    }
	
	
    // If there is supplemental text
    if( $supplimental = $arguments['supplemental'] ){
        printf( '<p class="description">%s</p>', $supplimental ); // Show it
    }				


    // Check which type of field we want
	switch( $arguments['type'] ){
		case 'text': // If it is a text field
			printf( '<input name="%1$s" id="%1$s" type="%2$s" placeholder="%3$s" value="%4$s" />', $arguments['uid'], $arguments['type'], $arguments['placeholder'], $value );
			break;
		case 'textarea': // If it is a textarea
			printf( '<textarea name="%1$s" id="%1$s" placeholder="%2$s" rows="5" cols="50">%3$s</textarea>', $arguments['uid'], $arguments['placeholder'], $value );
			break;
		case 'select': // If it is a select dropdown
			if( ! empty ( $arguments['options'] ) && is_array( $arguments['options'] ) ){
				$options_markup = '';
				foreach( $arguments['options'] as $key => $label ){
					$options_markup .= sprintf( '<option value="%s" %s>%s</option>', $key, selected( $value, $key, false ), $label );
				}
				printf( '<select name="%1$s" id="%1$s">%2$s</select>', $arguments['uid'], $options_markup );
			}
			break;
		case 'radio': // If it is a radio button list
			if( ! empty ( $arguments['options'] ) && is_array( $arguments['options'] ) ){
				$options_markup = '';
				foreach( $arguments['options'] as $key => $label ){
					
					//$options_markup .= sprintf( '<option value="%s" %s>%s</option>', $key, selected( $value, $key, false ), $label );
					$options_markup .= sprintf( '<input type="radio" name="'.$arguments['uid'].'" value="%s" %s>%s<br/>', $key, checked( $value, $key, false ), $label );
				}
				printf( '<div >%1$s</div>', $options_markup );
			}
			break;
	}
	
	
    // If there is help text
    if( $helper = $arguments['helper'] ){
        printf( '<span class="helper"> %s</span>', $helper ); // Show it
    }

				
				
			}



    }
	//fine class

}
// Load main plugin class
$ldv_gen = new WooCommerce_LDV_Generator();